// This file is automatically generated from /home/abuild/rpmbuild/BUILD/bro-2.4/src/analyzer/protocol/sip/sip.pac.


#ifdef __clang__
#pragma clang diagnostic ignored "-Wparentheses-equality"
#endif

#include "/home/abuild/rpmbuild/BUILD/bro-2.4/build/src/analyzer/protocol/sip/sip_pac.h"

namespace binpac {






namespace SIP {
ContextSIP::ContextSIP(SIP_Conn * connection, SIP_Flow * flow)
	{
	connection_ = connection;
	flow_ = flow;
	}

ContextSIP::~ContextSIP()
	{
	}

SIP_Conn::SIP_Conn(BroAnalyzer const & bro_analyzer)
	{
	upflow_ = new SIP_Flow(this, true);
	downflow_ = new SIP_Flow(this, false);
	bro_analyzer_ = bro_analyzer;
	}

SIP_Conn::~SIP_Conn()
	{
	delete upflow_;
	upflow_ = 0;
	delete downflow_;
	downflow_ = 0;
	}

void SIP_Conn::NewData(bool is_orig, const_byteptr begin, const_byteptr end)
	{
	if ( is_orig )
		upflow_->NewData(begin, end);
	else
		downflow_->NewData(begin, end);
	}

void SIP_Conn::NewGap(bool is_orig, int gap_length)
	{
	if ( is_orig )
		upflow_->NewGap(gap_length);
	else
		downflow_->NewGap(gap_length);
	}

void SIP_Conn::FlowEOF(bool is_orig)
	{
	if ( is_orig )
		upflow_->FlowEOF();
	else
		downflow_->FlowEOF();
	}

RegExMatcher SIP_TOKEN_re_001("[^()<>@,;:\\\"/\\[\\]?={} \\t]+");

RegExMatcher SIP_WS_re_002("[ \\t]*");

RegExMatcher SIP_COLON_re_003(":");

RegExMatcher SIP_TO_EOL_re_004("[^\\r\\n]*");

RegExMatcher SIP_EOL_re_005("(\\r\\n){1,2}");

RegExMatcher SIP_URI_re_006("[[:alnum:]@[:punct:]]+");

SIP_PDU::SIP_PDU(bool is_orig)
	{
	val_case_index_ = -1;
	request_ = 0;
	reply_ = 0;
	is_orig_ = is_orig;
	proc_ = 0;
	}

SIP_PDU::~SIP_PDU()
	{
	switch ( val_case_index() )
		{
		case 1:
			// Clean up "request"
			{
			delete request_;
			request_ = 0;
			}
			break;
		case 0:
			// Clean up "reply"
			{
			delete reply_;
			reply_ = 0;
			}
			break;
		}
	}

int SIP_PDU::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextSIP * t_context)
	{
	int t_val__size;
	val_case_index_ = is_orig();
	switch ( val_case_index() )
		{
		case 1:
			// Parse "request"
			{
			request_ = new SIP_Request();
			int t_request__size;
			t_request__size = request_->Parse(t_begin_of_data, t_end_of_data, t_context);
			// Evaluate 'let' and 'withinput' fields
			t_val__size = t_request__size;
			}
			break;
		case 0:
			// Parse "reply"
			{
			reply_ = new SIP_Reply();
			int t_reply__size;
			t_reply__size = reply_->Parse(t_begin_of_data, t_end_of_data, t_context);
			// Evaluate 'let' and 'withinput' fields
			t_val__size = t_reply__size;
			}
			break;
		default:
			throw binpac::ExceptionInvalidCaseIndex("SIP_PDU", val_case_index());
			break;
		}
	// Evaluate 'let' and 'withinput' fields
	proc_ = t_context->flow()->proc_sip_message_done(this);
	BINPAC_ASSERT(t_begin_of_data + (t_val__size) <= t_end_of_data);
	return t_val__size;
	}

SIP_Request::SIP_Request()
	{
	request_ = 0;
	msg_ = 0;
	}

SIP_Request::~SIP_Request()
	{
	delete request_;
	request_ = 0;
	delete msg_;
	msg_ = 0;
	}

int SIP_Request::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextSIP * t_context)
	{
	// Parse "request"
	request_ = new SIP_RequestLine();
	int t_request__size;
	t_request__size = request_->Parse(t_begin_of_data, t_end_of_data, t_context);
	// Evaluate 'let' and 'withinput' fields
	
	
	const_byteptr const t_dataptr_after_request = t_begin_of_data + (t_request__size);
	BINPAC_ASSERT(t_dataptr_after_request <= t_end_of_data);
	// Parse "msg"
	msg_ = new SIP_Message();
	int t_msg__size;
	t_msg__size = msg_->Parse((t_dataptr_after_request + 2), t_end_of_data, t_context);
	// Evaluate 'let' and 'withinput' fields
	
	int t_SIP_Request__size;
	const_byteptr const t_dataptr_after_msg = (t_dataptr_after_request + 2) + (t_msg__size);
	BINPAC_ASSERT(t_dataptr_after_msg <= t_end_of_data);
	t_SIP_Request__size = t_dataptr_after_msg - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_SIP_Request__size) <= t_end_of_data);
	return t_SIP_Request__size;
	}

SIP_Reply::SIP_Reply()
	{
	reply_ = 0;
	msg_ = 0;
	}

SIP_Reply::~SIP_Reply()
	{
	delete reply_;
	reply_ = 0;
	delete msg_;
	msg_ = 0;
	}

int SIP_Reply::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextSIP * t_context)
	{
	// Parse "reply"
	reply_ = new SIP_ReplyLine();
	int t_reply__size;
	t_reply__size = reply_->Parse(t_begin_of_data, t_end_of_data, t_context);
	// Evaluate 'let' and 'withinput' fields
	
	
	const_byteptr const t_dataptr_after_reply = t_begin_of_data + (t_reply__size);
	BINPAC_ASSERT(t_dataptr_after_reply <= t_end_of_data);
	// Parse "msg"
	msg_ = new SIP_Message();
	int t_msg__size;
	t_msg__size = msg_->Parse((t_dataptr_after_reply + 2), t_end_of_data, t_context);
	// Evaluate 'let' and 'withinput' fields
	
	int t_SIP_Reply__size;
	const_byteptr const t_dataptr_after_msg = (t_dataptr_after_reply + 2) + (t_msg__size);
	BINPAC_ASSERT(t_dataptr_after_msg <= t_end_of_data);
	t_SIP_Reply__size = t_dataptr_after_msg - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_SIP_Reply__size) <= t_end_of_data);
	return t_SIP_Reply__size;
	}

SIP_RequestLine::SIP_RequestLine()
	{
	version_ = 0;
	proc_ = 0;
	}

SIP_RequestLine::~SIP_RequestLine()
	{
	method_.free();
	uri_.free();
	delete version_;
	version_ = 0;
	}

int SIP_RequestLine::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextSIP * t_context)
	{
	// Parse "method"
	int t_method_string_length;
	t_method_string_length = 
		SIP_TOKEN_re_001.MatchPrefix(
			t_begin_of_data,
			t_end_of_data - t_begin_of_data);
	if ( t_method_string_length < 0 )
		{
		throw binpac::ExceptionStringMismatch("/home/abuild/rpmbuild/BUILD/bro-2.4/src/analyzer/protocol/sip/sip-protocol.pac:32", "[^()<>@,;:\\\"/\\[\\]?={} \\t]+", string((const char *) (t_begin_of_data), (const char *) t_end_of_data).c_str());
		}
	int t_method__size;
	t_method__size = t_method_string_length;
	// check for negative sizes
	if ( t_method_string_length < 0 )
	throw binpac::ExceptionInvalidStringLength("/home/abuild/rpmbuild/BUILD/bro-2.4/src/analyzer/protocol/sip/sip-protocol.pac:32", t_method_string_length);
	method_.init(t_begin_of_data, t_method_string_length);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_method = t_begin_of_data + (t_method__size);
	BINPAC_ASSERT(t_dataptr_after_method <= t_end_of_data);
	// Parse "anonymous_field_007"
	bytestring anonymous_field_007_;
	int t_anonymous_field_007_string_length;
	t_anonymous_field_007_string_length = 
		SIP_WS_re_002.MatchPrefix(
			t_dataptr_after_method,
			t_end_of_data - t_dataptr_after_method);
	if ( t_anonymous_field_007_string_length < 0 )
		{
		throw binpac::ExceptionStringMismatch("/home/abuild/rpmbuild/BUILD/bro-2.4/src/analyzer/protocol/sip/sip-protocol.pac:33", "[ \\t]*", string((const char *) (t_dataptr_after_method), (const char *) t_end_of_data).c_str());
		}
	int t_anonymous_field_007__size;
	t_anonymous_field_007__size = t_anonymous_field_007_string_length;
	// Evaluate 'let' and 'withinput' fields
	anonymous_field_007_.free();
	
	const_byteptr const t_dataptr_after_anonymous_field_007 = t_dataptr_after_method + (t_anonymous_field_007__size);
	BINPAC_ASSERT(t_dataptr_after_anonymous_field_007 <= t_end_of_data);
	// Parse "uri"
	int t_uri_string_length;
	t_uri_string_length = 
		SIP_URI_re_006.MatchPrefix(
			t_dataptr_after_anonymous_field_007,
			t_end_of_data - t_dataptr_after_anonymous_field_007);
	if ( t_uri_string_length < 0 )
		{
		throw binpac::ExceptionStringMismatch("/home/abuild/rpmbuild/BUILD/bro-2.4/src/analyzer/protocol/sip/sip-protocol.pac:34", "[[:alnum:]@[:punct:]]+", string((const char *) (t_dataptr_after_anonymous_field_007), (const char *) t_end_of_data).c_str());
		}
	int t_uri__size;
	t_uri__size = t_uri_string_length;
	// check for negative sizes
	if ( t_uri_string_length < 0 )
	throw binpac::ExceptionInvalidStringLength("/home/abuild/rpmbuild/BUILD/bro-2.4/src/analyzer/protocol/sip/sip-protocol.pac:34", t_uri_string_length);
	uri_.init(t_dataptr_after_anonymous_field_007, t_uri_string_length);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_uri = t_dataptr_after_anonymous_field_007 + (t_uri__size);
	BINPAC_ASSERT(t_dataptr_after_uri <= t_end_of_data);
	// Parse "anonymous_field_008"
	bytestring anonymous_field_008_;
	int t_anonymous_field_008_string_length;
	t_anonymous_field_008_string_length = 
		SIP_WS_re_002.MatchPrefix(
			t_dataptr_after_uri,
			t_end_of_data - t_dataptr_after_uri);
	if ( t_anonymous_field_008_string_length < 0 )
		{
		throw binpac::ExceptionStringMismatch("/home/abuild/rpmbuild/BUILD/bro-2.4/src/analyzer/protocol/sip/sip-protocol.pac:35", "[ \\t]*", string((const char *) (t_dataptr_after_uri), (const char *) t_end_of_data).c_str());
		}
	int t_anonymous_field_008__size;
	t_anonymous_field_008__size = t_anonymous_field_008_string_length;
	// Evaluate 'let' and 'withinput' fields
	anonymous_field_008_.free();
	
	const_byteptr const t_dataptr_after_anonymous_field_008 = t_dataptr_after_uri + (t_anonymous_field_008__size);
	BINPAC_ASSERT(t_dataptr_after_anonymous_field_008 <= t_end_of_data);
	// Parse "version"
	version_ = new SIP_Version();
	int t_version__size;
	t_version__size = version_->Parse(t_dataptr_after_anonymous_field_008, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	int t_SIP_RequestLine__size;
	const_byteptr const t_dataptr_after_version = t_dataptr_after_anonymous_field_008 + (t_version__size);
	BINPAC_ASSERT(t_dataptr_after_version <= t_end_of_data);
	t_SIP_RequestLine__size = t_dataptr_after_version - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	proc_ = t_context->flow()->proc_sip_request(method(), uri(), version());
	BINPAC_ASSERT(t_begin_of_data + (t_SIP_RequestLine__size) <= t_end_of_data);
	return t_SIP_RequestLine__size;
	}

SIP_ReplyLine::SIP_ReplyLine()
	{
	version_ = 0;
	status_ = 0;
	proc_ = 0;
	}

SIP_ReplyLine::~SIP_ReplyLine()
	{
	delete version_;
	version_ = 0;
	delete status_;
	status_ = 0;
	reason_.free();
	}

int SIP_ReplyLine::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextSIP * t_context)
	{
	// Parse "version"
	version_ = new SIP_Version();
	int t_version__size;
	t_version__size = version_->Parse(t_begin_of_data, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_version = t_begin_of_data + (t_version__size);
	BINPAC_ASSERT(t_dataptr_after_version <= t_end_of_data);
	// Parse "anonymous_field_009"
	bytestring anonymous_field_009_;
	int t_anonymous_field_009_string_length;
	t_anonymous_field_009_string_length = 
		SIP_WS_re_002.MatchPrefix(
			t_dataptr_after_version,
			t_end_of_data - t_dataptr_after_version);
	if ( t_anonymous_field_009_string_length < 0 )
		{
		throw binpac::ExceptionStringMismatch("/home/abuild/rpmbuild/BUILD/bro-2.4/src/analyzer/protocol/sip/sip-protocol.pac:41", "[ \\t]*", string((const char *) (t_dataptr_after_version), (const char *) t_end_of_data).c_str());
		}
	int t_anonymous_field_009__size;
	t_anonymous_field_009__size = t_anonymous_field_009_string_length;
	// Evaluate 'let' and 'withinput' fields
	anonymous_field_009_.free();
	
	const_byteptr const t_dataptr_after_anonymous_field_009 = t_dataptr_after_version + (t_anonymous_field_009__size);
	BINPAC_ASSERT(t_dataptr_after_anonymous_field_009 <= t_end_of_data);
	// Parse "status"
	status_ = new SIP_Status();
	int t_status__size;
	t_status__size = status_->Parse(t_dataptr_after_anonymous_field_009, t_end_of_data);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_status = t_dataptr_after_anonymous_field_009 + (t_status__size);
	BINPAC_ASSERT(t_dataptr_after_status <= t_end_of_data);
	// Parse "anonymous_field_010"
	bytestring anonymous_field_010_;
	int t_anonymous_field_010_string_length;
	t_anonymous_field_010_string_length = 
		SIP_WS_re_002.MatchPrefix(
			t_dataptr_after_status,
			t_end_of_data - t_dataptr_after_status);
	if ( t_anonymous_field_010_string_length < 0 )
		{
		throw binpac::ExceptionStringMismatch("/home/abuild/rpmbuild/BUILD/bro-2.4/src/analyzer/protocol/sip/sip-protocol.pac:43", "[ \\t]*", string((const char *) (t_dataptr_after_status), (const char *) t_end_of_data).c_str());
		}
	int t_anonymous_field_010__size;
	t_anonymous_field_010__size = t_anonymous_field_010_string_length;
	// Evaluate 'let' and 'withinput' fields
	anonymous_field_010_.free();
	
	const_byteptr const t_dataptr_after_anonymous_field_010 = t_dataptr_after_status + (t_anonymous_field_010__size);
	BINPAC_ASSERT(t_dataptr_after_anonymous_field_010 <= t_end_of_data);
	// Parse "reason"
	int t_reason_string_length;
	t_reason_string_length = 
		SIP_TO_EOL_re_004.MatchPrefix(
			t_dataptr_after_anonymous_field_010,
			t_end_of_data - t_dataptr_after_anonymous_field_010);
	if ( t_reason_string_length < 0 )
		{
		throw binpac::ExceptionStringMismatch("/home/abuild/rpmbuild/BUILD/bro-2.4/src/analyzer/protocol/sip/sip-protocol.pac:44", "[^\\r\\n]*", string((const char *) (t_dataptr_after_anonymous_field_010), (const char *) t_end_of_data).c_str());
		}
	int t_reason__size;
	t_reason__size = t_reason_string_length;
	// check for negative sizes
	if ( t_reason_string_length < 0 )
	throw binpac::ExceptionInvalidStringLength("/home/abuild/rpmbuild/BUILD/bro-2.4/src/analyzer/protocol/sip/sip-protocol.pac:44", t_reason_string_length);
	reason_.init(t_dataptr_after_anonymous_field_010, t_reason_string_length);
	// Evaluate 'let' and 'withinput' fields
	
	int t_SIP_ReplyLine__size;
	const_byteptr const t_dataptr_after_reason = t_dataptr_after_anonymous_field_010 + (t_reason__size);
	BINPAC_ASSERT(t_dataptr_after_reason <= t_end_of_data);
	t_SIP_ReplyLine__size = t_dataptr_after_reason - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	proc_ = t_context->flow()->proc_sip_reply(version(), status()->stat_num(), reason());
	BINPAC_ASSERT(t_begin_of_data + (t_SIP_ReplyLine__size) <= t_end_of_data);
	return t_SIP_ReplyLine__size;
	}

RegExMatcher SIP_Status_re_011("[0-9]{3}");

SIP_Status::SIP_Status()
	{
	stat_num_ = 0;
	}

SIP_Status::~SIP_Status()
	{
	stat_str_.free();
	}

int SIP_Status::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Parse "stat_str"
	int t_stat_str_string_length;
	t_stat_str_string_length = 
		SIP_Status_re_011.MatchPrefix(
			t_begin_of_data,
			t_end_of_data - t_begin_of_data);
	if ( t_stat_str_string_length < 0 )
		{
		throw binpac::ExceptionStringMismatch("/home/abuild/rpmbuild/BUILD/bro-2.4/src/analyzer/protocol/sip/sip-protocol.pac:48", "[0-9]{3}", string((const char *) (t_begin_of_data), (const char *) t_end_of_data).c_str());
		}
	int t_stat_str__size;
	t_stat_str__size = t_stat_str_string_length;
	// check for negative sizes
	if ( t_stat_str_string_length < 0 )
	throw binpac::ExceptionInvalidStringLength("/home/abuild/rpmbuild/BUILD/bro-2.4/src/analyzer/protocol/sip/sip-protocol.pac:48", t_stat_str_string_length);
	stat_str_.init(t_begin_of_data, t_stat_str_string_length);
	// Evaluate 'let' and 'withinput' fields
	
	int t_SIP_Status__size;
	const_byteptr const t_dataptr_after_stat_str = t_begin_of_data + (t_stat_str__size);
	BINPAC_ASSERT(t_dataptr_after_stat_str <= t_end_of_data);
	t_SIP_Status__size = t_dataptr_after_stat_str - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	stat_num_ = bytestring_to_int(stat_str(), 10);
	BINPAC_ASSERT(t_begin_of_data + (t_SIP_Status__size) <= t_end_of_data);
	return t_SIP_Status__size;
	}

RegExMatcher SIP_Version_re_013("[0-9]+\\.[0-9]+");

SIP_Version::SIP_Version()
	{
	vers_num_ = 0;
	}

SIP_Version::~SIP_Version()
	{
	vers_str_.free();
	}

int SIP_Version::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data)
	{
	// Checking out-of-bound for "SIP_Version:anonymous_field_012"
	if ( t_begin_of_data + (4) > t_end_of_data || t_begin_of_data + (4) < t_begin_of_data )
		{
		// Handle out-of-bound condition
		throw binpac::ExceptionOutOfBound("SIP_Version:anonymous_field_012",
			(0) + (4), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "anonymous_field_012"
	bytestring anonymous_field_012_;
	if ( memcmp(t_begin_of_data, "SIP/", 4) != 0 )
		{
		throw binpac::ExceptionStringMismatch("/home/abuild/rpmbuild/BUILD/bro-2.4/src/analyzer/protocol/sip/sip-protocol.pac:54", "SIP/", string((const char *) (t_begin_of_data), (const char *) t_end_of_data).c_str());
		}
	// Evaluate 'let' and 'withinput' fields
	anonymous_field_012_.free();
	
	// Parse "vers_str"
	int t_vers_str_string_length;
	t_vers_str_string_length = 
		SIP_Version_re_013.MatchPrefix(
			(t_begin_of_data + 4),
			t_end_of_data - (t_begin_of_data + 4));
	if ( t_vers_str_string_length < 0 )
		{
		throw binpac::ExceptionStringMismatch("/home/abuild/rpmbuild/BUILD/bro-2.4/src/analyzer/protocol/sip/sip-protocol.pac:55", "[0-9]+\\.[0-9]+", string((const char *) ((t_begin_of_data + 4)), (const char *) t_end_of_data).c_str());
		}
	int t_vers_str__size;
	t_vers_str__size = t_vers_str_string_length;
	// check for negative sizes
	if ( t_vers_str_string_length < 0 )
	throw binpac::ExceptionInvalidStringLength("/home/abuild/rpmbuild/BUILD/bro-2.4/src/analyzer/protocol/sip/sip-protocol.pac:55", t_vers_str_string_length);
	vers_str_.init((t_begin_of_data + 4), t_vers_str_string_length);
	// Evaluate 'let' and 'withinput' fields
	
	int t_SIP_Version__size;
	const_byteptr const t_dataptr_after_vers_str = (t_begin_of_data + 4) + (t_vers_str__size);
	BINPAC_ASSERT(t_dataptr_after_vers_str <= t_end_of_data);
	t_SIP_Version__size = t_dataptr_after_vers_str - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	vers_num_ = bytestring_to_double(vers_str());
	BINPAC_ASSERT(t_begin_of_data + (t_SIP_Version__size) <= t_end_of_data);
	return t_SIP_Version__size;
	}

SIP_Headers::SIP_Headers()
	{
	val_ = 0;
	val__elem_ = 0;
	proc_ = 0;
	}

SIP_Headers::~SIP_Headers()
	{
	delete val__elem_;
	val__elem_ = 0;
	if ( val() )
		{
		for ( int i = 0; i < (int) val()->size(); ++i )
			{
			SIP_Header * val__elem_ = (*val_)[i];
			delete val__elem_;
			val__elem_ = 0;
			}
		}
	delete val_;
	}

int SIP_Headers::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextSIP * t_context)
	{
	int t_val__arraylength;
	t_val__arraylength = 0;
	val__elem_ = 0;
	int t_val__elem__it;
	t_val__elem__it = 0;
	int t_val__size;
	val_ = new vector<SIP_Header *>;
	const_byteptr t_val__elem__dataptr = t_begin_of_data;
	for (; /* forever */; ++t_val__elem__it)
		{
		// Check &until(val__elem__dataptr >= end_of_data)
		if ( t_val__elem__dataptr >= t_end_of_data )
			{
			val__elem_ = 0;
			goto end_of_val;
			}
		val__elem_ = new SIP_Header();
		int t_val__elem__size;
		t_val__elem__size = val__elem_->Parse(t_val__elem__dataptr, t_end_of_data, t_context);
		// Evaluate 'let' and 'withinput' fields
		val_->push_back(val__elem_);
		t_val__elem__dataptr += t_val__elem__size;
		BINPAC_ASSERT(t_val__elem__dataptr <= t_end_of_data);
		val__elem_ = 0;
		}
end_of_val: ;
	t_val__size = t_val__elem__dataptr - (t_begin_of_data);
	// Evaluate 'let' and 'withinput' fields
	proc_ = t_context->flow()->proc_sip_end_of_headers(this);
	BINPAC_ASSERT(t_begin_of_data + (t_val__size) <= t_end_of_data);
	return t_val__size;
	}

SIP_Message::SIP_Message()
	{
	headers_ = 0;
	body_ = 0;
	}

SIP_Message::~SIP_Message()
	{
	delete headers_;
	headers_ = 0;
	delete body_;
	body_ = 0;
	}

int SIP_Message::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextSIP * t_context)
	{
	// Parse "headers"
	headers_ = new SIP_Headers();
	int t_headers__size;
	t_headers__size = headers_->Parse(t_begin_of_data, t_end_of_data, t_context);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_headers = t_begin_of_data + (t_headers__size);
	BINPAC_ASSERT(t_dataptr_after_headers <= t_end_of_data);
	// Parse "body"
	body_ = new SIP_Body();
	int t_body__size;
	t_body__size = body_->Parse(t_dataptr_after_headers, t_end_of_data, t_context);
	// Evaluate 'let' and 'withinput' fields
	
	int t_SIP_Message__size;
	const_byteptr const t_dataptr_after_body = t_dataptr_after_headers + (t_body__size);
	BINPAC_ASSERT(t_dataptr_after_body <= t_end_of_data);
	t_SIP_Message__size = t_dataptr_after_body - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_SIP_Message__size) <= t_end_of_data);
	return t_SIP_Message__size;
	}

RegExMatcher SIP_HEADER_NAME_re_014("[^: \\t]+");

SIP_Header::SIP_Header()
	{
	byteorder_ = bigendian;
	proc_ = 0;
	}

SIP_Header::~SIP_Header()
	{
	name_.free();
	value_.free();
	}

int SIP_Header::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextSIP * t_context)
	{
	// Parse "name"
	int t_name_string_length;
	t_name_string_length = 
		SIP_HEADER_NAME_re_014.MatchPrefix(
			t_begin_of_data,
			t_end_of_data - t_begin_of_data);
	if ( t_name_string_length < 0 )
		{
		throw binpac::ExceptionStringMismatch("/home/abuild/rpmbuild/BUILD/bro-2.4/src/analyzer/protocol/sip/sip-protocol.pac:69", "[^: \\t]+", string((const char *) (t_begin_of_data), (const char *) t_end_of_data).c_str());
		}
	int t_name__size;
	t_name__size = t_name_string_length;
	// check for negative sizes
	if ( t_name_string_length < 0 )
	throw binpac::ExceptionInvalidStringLength("/home/abuild/rpmbuild/BUILD/bro-2.4/src/analyzer/protocol/sip/sip-protocol.pac:69", t_name_string_length);
	name_.init(t_begin_of_data, t_name_string_length);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_name = t_begin_of_data + (t_name__size);
	BINPAC_ASSERT(t_dataptr_after_name <= t_end_of_data);
	// Parse "anonymous_field_015"
	bytestring anonymous_field_015_;
	int t_anonymous_field_015_string_length;
	t_anonymous_field_015_string_length = 
		SIP_COLON_re_003.MatchPrefix(
			t_dataptr_after_name,
			t_end_of_data - t_dataptr_after_name);
	if ( t_anonymous_field_015_string_length < 0 )
		{
		throw binpac::ExceptionStringMismatch("/home/abuild/rpmbuild/BUILD/bro-2.4/src/analyzer/protocol/sip/sip-protocol.pac:70", ":", string((const char *) (t_dataptr_after_name), (const char *) t_end_of_data).c_str());
		}
	int t_anonymous_field_015__size;
	t_anonymous_field_015__size = t_anonymous_field_015_string_length;
	// Evaluate 'let' and 'withinput' fields
	anonymous_field_015_.free();
	
	const_byteptr const t_dataptr_after_anonymous_field_015 = t_dataptr_after_name + (t_anonymous_field_015__size);
	BINPAC_ASSERT(t_dataptr_after_anonymous_field_015 <= t_end_of_data);
	// Parse "anonymous_field_016"
	bytestring anonymous_field_016_;
	int t_anonymous_field_016_string_length;
	t_anonymous_field_016_string_length = 
		SIP_WS_re_002.MatchPrefix(
			t_dataptr_after_anonymous_field_015,
			t_end_of_data - t_dataptr_after_anonymous_field_015);
	if ( t_anonymous_field_016_string_length < 0 )
		{
		throw binpac::ExceptionStringMismatch("/home/abuild/rpmbuild/BUILD/bro-2.4/src/analyzer/protocol/sip/sip-protocol.pac:71", "[ \\t]*", string((const char *) (t_dataptr_after_anonymous_field_015), (const char *) t_end_of_data).c_str());
		}
	int t_anonymous_field_016__size;
	t_anonymous_field_016__size = t_anonymous_field_016_string_length;
	// Evaluate 'let' and 'withinput' fields
	anonymous_field_016_.free();
	
	const_byteptr const t_dataptr_after_anonymous_field_016 = t_dataptr_after_anonymous_field_015 + (t_anonymous_field_016__size);
	BINPAC_ASSERT(t_dataptr_after_anonymous_field_016 <= t_end_of_data);
	// Parse "value"
	int t_value_string_length;
	t_value_string_length = 
		SIP_TO_EOL_re_004.MatchPrefix(
			t_dataptr_after_anonymous_field_016,
			t_end_of_data - t_dataptr_after_anonymous_field_016);
	if ( t_value_string_length < 0 )
		{
		throw binpac::ExceptionStringMismatch("/home/abuild/rpmbuild/BUILD/bro-2.4/src/analyzer/protocol/sip/sip-protocol.pac:72", "[^\\r\\n]*", string((const char *) (t_dataptr_after_anonymous_field_016), (const char *) t_end_of_data).c_str());
		}
	int t_value__size;
	t_value__size = t_value_string_length;
	// check for negative sizes
	if ( t_value_string_length < 0 )
	throw binpac::ExceptionInvalidStringLength("/home/abuild/rpmbuild/BUILD/bro-2.4/src/analyzer/protocol/sip/sip-protocol.pac:72", t_value_string_length);
	value_.init(t_dataptr_after_anonymous_field_016, t_value_string_length);
	// Evaluate 'let' and 'withinput' fields
	
	const_byteptr const t_dataptr_after_value = t_dataptr_after_anonymous_field_016 + (t_value__size);
	BINPAC_ASSERT(t_dataptr_after_value <= t_end_of_data);
	// Parse "anonymous_field_017"
	bytestring anonymous_field_017_;
	int t_anonymous_field_017_string_length;
	t_anonymous_field_017_string_length = 
		SIP_EOL_re_005.MatchPrefix(
			t_dataptr_after_value,
			t_end_of_data - t_dataptr_after_value);
	if ( t_anonymous_field_017_string_length < 0 )
		{
		throw binpac::ExceptionStringMismatch("/home/abuild/rpmbuild/BUILD/bro-2.4/src/analyzer/protocol/sip/sip-protocol.pac:73", "(\\r\\n){1,2}", string((const char *) (t_dataptr_after_value), (const char *) t_end_of_data).c_str());
		}
	int t_anonymous_field_017__size;
	t_anonymous_field_017__size = t_anonymous_field_017_string_length;
	// Evaluate 'let' and 'withinput' fields
	anonymous_field_017_.free();
	
	int t_SIP_Header__size;
	const_byteptr const t_dataptr_after_anonymous_field_017 = t_dataptr_after_value + (t_anonymous_field_017__size);
	BINPAC_ASSERT(t_dataptr_after_anonymous_field_017 <= t_end_of_data);
	t_SIP_Header__size = t_dataptr_after_anonymous_field_017 - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	proc_ = t_context->flow()->proc_sip_header(name(), value());
	BINPAC_ASSERT(t_begin_of_data + (t_SIP_Header__size) <= t_end_of_data);
	return t_SIP_Header__size;
	}

SIP_Body::SIP_Body()
	{
	}

SIP_Body::~SIP_Body()
	{
	body_.free();
	}

int SIP_Body::Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextSIP * t_context)
	{
	// Parse "body"
	int t_body__size;
	t_body__size = t_context->flow()->get_content_length();
	// Checking out-of-bound for "SIP_Body:body"
	if ( t_begin_of_data + (t_body__size) > t_end_of_data || t_begin_of_data + (t_body__size) < t_begin_of_data )
		{
		// Handle out-of-bound condition
		throw binpac::ExceptionOutOfBound("SIP_Body:body",
			(0) + (t_body__size), 
			(t_end_of_data) - (t_begin_of_data));
		}
	{
	// Setting t_end_of_data with &length
	const_byteptr t_end_of_data = t_begin_of_data + t_body__size;
	int t_body_string_length;
	t_body_string_length = t_context->flow()->get_content_length();
	// check for negative sizes
	if ( t_body_string_length < 0 )
	throw binpac::ExceptionInvalidStringLength("/home/abuild/rpmbuild/BUILD/bro-2.4/src/analyzer/protocol/sip/sip-protocol.pac:77", t_body_string_length);
	body_.init(t_begin_of_data, t_body_string_length);
	// Evaluate 'let' and 'withinput' fields
	}
	
	int t_SIP_Body__size;
	const_byteptr const t_dataptr_after_body = t_begin_of_data + (t_body__size);
	BINPAC_ASSERT(t_dataptr_after_body <= t_end_of_data);
	t_SIP_Body__size = t_dataptr_after_body - t_begin_of_data;
	// Evaluate 'let' and 'withinput' fields
	BINPAC_ASSERT(t_begin_of_data + (t_SIP_Body__size) <= t_end_of_data);
	return t_SIP_Body__size;
	}

SIP_Flow::SIP_Flow(SIP_Conn * connection, bool is_orig)
	{
	connection_ = connection;
	is_orig_ = is_orig;

		content_length = 0;
		build_headers = (sip_all_headers != 0);
	
	dataunit_ = 0;
	context_ = 0;
	}

SIP_Flow::~SIP_Flow()
	{
	delete dataunit_;
	dataunit_ = 0;
	delete context_;
	context_ = 0;
	}

void SIP_Flow::NewData(const_byteptr t_begin_of_data, const_byteptr t_end_of_data)
	{
	try
		{
		dataunit_ = new SIP_PDU(is_orig());
		context_ = new ContextSIP(connection(), this);
		int t_dataunit__size;
		t_dataunit__size = dataunit_->Parse(t_begin_of_data, t_end_of_data, context_);
		// Evaluate 'let' and 'withinput' fields
		delete dataunit_;
		dataunit_ = 0;
		delete context_;
		context_ = 0;
		}
	catch ( binpac::Exception const &e )
		{
		delete dataunit_;
		dataunit_ = 0;
		delete context_;
		context_ = 0;
		throw;
		}
	}

void SIP_Flow::NewGap(int gap_length)
	{
	}
void SIP_Flow::FlowEOF()
	{
	}
int SIP_Flow::get_content_length()
	{

		return content_length;
		
	}

bool SIP_Flow::proc_sip_request(bytestring const & method, bytestring const & uri, SIP_Version * vers)
	{

		connection()->bro_analyzer()->ProtocolConfirmation();
		if ( sip_request )
			{
			BifEvent::generate_sip_request(connection()->bro_analyzer(), connection()->bro_analyzer()->Conn(),
						       bytestring_to_val(method), bytestring_to_val(uri),
						       bytestring_to_val(vers->vers_str()));
			}

		proc_sip_message_begin();

		return true;
		
	}

bool SIP_Flow::proc_sip_reply(SIP_Version * vers, int code, bytestring const & reason)
	{

		connection()->bro_analyzer()->ProtocolConfirmation();
		if ( sip_reply )
			{
			BifEvent::generate_sip_reply(connection()->bro_analyzer(), connection()->bro_analyzer()->Conn(),
						     bytestring_to_val(vers->vers_str()), code, bytestring_to_val(reason));
			}

		proc_sip_message_begin();

		return true;
		
	}

bool SIP_Flow::proc_sip_header(bytestring const & name, bytestring const & value)
	{

		if ( name == "Content-Length" || name == "L" )
			content_length = bytestring_to_int(value, 10);

		if ( sip_header )
			{
			BifEvent::generate_sip_header(connection()->bro_analyzer(), connection()->bro_analyzer()->Conn(),
						      is_orig(), bytestring_to_val(name)->ToUpper(), bytestring_to_val(value));
			}

		if ( build_headers )
			{
			headers.push_back(build_sip_header_val(name, value));
			}

		return true;
		
	}

BroVal SIP_Flow::build_sip_headers_val()
	{

		TableVal* t = new TableVal(mime_header_list);

		for ( unsigned int i = 0; i < headers.size(); ++i )
			{ // index starting from 1
			Val* index = new Val(i + 1, TYPE_COUNT);
			t->Assign(index, headers[i]);
			Unref(index);
			}

		return t;
		
	}

void SIP_Flow::gen_sip_all_headers()
	{

		if ( sip_all_headers )
			{
			BifEvent::generate_sip_all_headers(connection()->bro_analyzer(), connection()->bro_analyzer()->Conn(),
							   is_orig(), build_sip_headers_val());
			}

		headers.clear();
		
	}

bool SIP_Flow::proc_sip_end_of_headers(SIP_Headers * headers)
	{

		if ( build_headers )
			{
			gen_sip_all_headers();
			}

		return true;
		
	}

BroVal SIP_Flow::build_sip_header_val(const_bytestring const & name, const_bytestring const & value)
	{

		RecordVal* header_record = new RecordVal(mime_header_rec);

		StringVal* name_val = 0;
		if ( name.length() > 0 )
			{
			// Make it all uppercase.
			name_val = new StringVal(name.length(), (const char*) name.begin());
			name_val->ToUpper();
			}
		else
			{
			name_val = new StringVal("");
			}

		header_record->Assign(0, name_val);
		header_record->Assign(1, bytestring_to_val(value));

		return header_record;
		
	}

void SIP_Flow::proc_sip_message_begin()
	{

		if ( sip_begin_entity )
			{
			BifEvent::generate_sip_begin_entity(connection()->bro_analyzer(), connection()->bro_analyzer()->Conn(), is_orig());
			}
		
	}

bool SIP_Flow::proc_sip_message_done(SIP_PDU * pdu)
	{

		if ( sip_end_entity )
			{
			BifEvent::generate_sip_end_entity(connection()->bro_analyzer(), connection()->bro_analyzer()->Conn(), is_orig());
			}

		return true;
		
	}

} // namespace SIP
}  // namespace binpac
